{$O+,F+}
unit pczx;
interface
uses dos;

{=========For PC============}
const max=1985;
var makeboot:boolean;
    altF5press:boolean;
type hobrec=record
             name:string[8];
             typ:char;
             start:word;
             length:word;
             totalsec:byte;
            end;
var hobetainfo:hobrec;

function et(n:longint; lang:byte):string;
function eb(n:longint; lang:byte):string;

function isTRD(path:pathstr):boolean;
function ithobeta(name:string; var rec:hobrec):boolean;

function  CQuestion (quest:string; lan:byte):boolean;

procedure putcmdline;
procedure pcinfo;
procedure pcSelInfo;
procedure pcdirinfo;
procedure infopanel;


function checkpath(p:pathstr):pathstr;

procedure pcInverseLeft;
procedure pcInverseRight;

procedure pcMinusLeft;
procedure pcMinusRight;

procedure pcPlusLeft;
procedure pcPlusRight;
procedure pcCtrlPlusLeft;
procedure pcCtrlPlusRight;

procedure pcInsLeft;
procedure pcInsRight;



{=========For ZX============}
const trdmax=129;

Function CRC16(InString: String) : Word;

procedure trdInsLeft;
procedure trdInsRight;
procedure trdPlusLeft;
procedure trdPlusRight;
procedure trdMinusLeft;
procedure trdMinusRight;
procedure trdInverseLeft;
procedure trdInverseRight;

function bpos(tr,sc:byte):longint;

implementation
uses crt,rv, panels,main,pallete, ovr_main,ovr_pc,ovr_zx;



Function CRC16(InString: String) : Word;
Var
  CRC     : Word;
  Index1,
  Index2  : Byte;
begin
  CRC := 0;
  For Index1 := 1 to length(InString) do
  begin
    CRC := (CRC xor (ord(InString[Index1]) SHL 8));
    For Index2 := 1 to 8 do
      if ((CRC and $8000) <> 0) then
        CRC := ((CRC SHL 1) xor $1021)
      else
        CRC := (CRC SHL 1)
  end;
  CRC16 := (CRC and $FFFF)
end;




{=========Block For PC============}



function et(n:longint; lang:byte):string;
var
   i:longint;
begin
i:=n div 10; i:=i*10; i:=n-i;
if lang=rus then
 begin
  case i of
   0: et:='';
   1: et:='';
   2: et:='';
   3: et:='';
   4: et:='';
   5: et:='';
   6: et:='';
   7: et:='';
   8: et:='';
   9: et:='';
  end;
  if n=11 then et:='';
  if n=12 then et:='';
  if n=13 then et:='';
  if n=14 then et:='';
 end
else
 begin
  if n=1 then et:='' else et:='s';
 end;
end;

function eb(n:longint; lang:byte):string;
var
   i:longint; s:string;
begin
s:=(strr(n));
s:=s[length(s)-1]+s[length(s)];
i:=n div 10; i:=i*10; i:=n-i;
if lang=rus then
 begin
  case i of
   0: eb:='';
   1: eb:='';
   2: eb:='';
   3: eb:='';
   4: eb:='';
   5: eb:='';
   6: eb:='';
   7: eb:='';
   8: eb:='';
   9: eb:='';
  end;
  if n=11 then eb:='';
  if n=12 then eb:='';
  if n=13 then eb:='';
  if n=14 then eb:='';
  if vall(s)=11 then eb:='';
  if vall(s)=12 then eb:='';
  if vall(s)=13 then eb:='';
  if vall(s)=14 then eb:='';
 end
else
 begin
  if n=1 then eb:='' else eb:='s';
 end;
end;






function isTRD(path:pathstr):boolean;
var fb:file of byte;
    b:byte;
    i:integer;
label fin,fin2;
begin
isTRD:=false;
{if filelen(path)<>655360 then goto fin2;{}
{$I-}
filemode:=0;
assign(fb,path); reset(fb);
{
seek(fb,$800); read(fb,b);
if not (b in [$0]) then goto fin;{}
seek(fb,$8e3); read(fb,b);
if not (b in [$16,$17,$18,$19]) then goto fin;
seek(fb,$8e4); read(fb,b);
if not (b in [0..128]) then goto fin;{}
seek(fb,$8e7); read(fb,b);
if not (b in [$10]) then goto fin;
{if not (buf[$e6]*256+buf[$e5] in [0..2544]) then exit;}
isTRD:=true;
fin:
close(fb);
{$I+}
fin2:
if ioresult<>0 then exit;
end;


function ithobeta(name:string; var rec:hobrec):boolean;
var
   i,a,b:byte;
   s,c:word;
   hob:array[0..16]of byte;
   fb:file of byte;
   temp:hobrec;
begin
{$I-}
ithobeta:=false;
if checkdirfile(name)<>0 then exit;
filemode:=0;
assign(fb,name); reset(fb); seek(fb,0); for i:=0 to 16 do read(fb,hob[i]); close(fb);
if ioresult<>0 then;
{$I+}

s:=0; for i:=0 to 14 do s:=s+257*hob[i]+i;
a:=hob[16]; b:=hob[15]; c:=256*a+b;
if c<>s then exit;
ithobeta:=true;

temp.name:=space(8);
for i:=0 to 7 do temp.name[i+1]:=chr(hob[i]);
temp.typ:=chr(hob[8]);
temp.start:=hob[9]+256*hob[10];
temp.length:=hob[11]+256*hob[12];
temp.totalsec:=hob[14];
rec:=temp;
end;








{============================================================================}
{== COLOR QESTION ===========================================================}
{============================================================================}
function  CQuestion (quest:string; lan:byte):boolean;
var
   k:char;
   cm,m,a,b:integer;
   x1,x2,dx:byte;
   yes,no,s:string;
label l;
begin
CurOff;
if lan=rus then
 begin yes:='      '; no:= '     '; end
else
 begin yes:='  Yes   '; no:= '   No   '; end;
cm:=halfmaxy;
if length(quest)<5 then dx:=5 else dx:=0;
x1:=halfmaxx-20;
x2:=halfmaxx+21;
Colour(bkdRama,txtdRama); sPutWin(x1,cm-4,x2,cm+3);
if lan=rus then
cmcentre(bkdRama,txtdRama,cm-4,' ⢥p ')
else cmcentre(bkdRama,txtdRama,cm-4,' Confirmation ');

if length(quest)<>length(without(quest,#255)) then
 begin
  CStatusLineColor(bkdStatic,txtdStatic,txtdStatic,cm-2,copy(quest,1,pos(#255,quest)));
  CStatusLineColor(bkdStatic,txtdStatic,txtdStatic,cm-1,copy(quest,pos(#255,quest)+1,255));
 end
else
 CStatusLineColor(bkdStatic,txtdStatic,txtdStatic,cm-2,quest);

colour(bkdRama,0);
m:=1;
l:
 if m=1 then
  begin
   cbutton(bkdButtonA,txtdButtonA,halfmaxx-9,cm+1,yes,true);
   cbutton(bkdButtonNA,txtdButtonNA,halfmaxx+3,cm+1,no,false);
  end
 else
  begin
   cbutton(bkdButtonNA,txtdButtonNA,halfmaxx-9,cm+1,yes,false);
   cbutton(bkdButtonA,txtdButtonA,halfmaxx+3,cm+1,no,true);
  end;
{if rMoused then MouseShow;{}
 k:=ReadKey;
 if k=#27 then begin CQuestion:=false; RestScr; Exit; end;
 if k=#13 then begin if m=0 then CQuestion:=false else CQuestion:=true; RestScr; Exit; end;
 if k=#0 then
  begin
   k:=ReadKey;
   if k=#77 then m:=0;
   if k=#75 then m:=1;
  end;
goto l;
end;




procedure putcmdline;
var stemp,c:string;
begin
if not cmdlined then exit;
case focus of
 left:
  begin
      if lp.treec=1 then stemp:=lp.pcnd else stemp:=copy(lp.pcnd,1,length(lp.pcnd)-1);
      cmprint(0,15,1,gmaxy-1,stemp+'>');
      if length(command)>78-length(stemp+'>')then c:=copy(command,(length(command)-(78-length(stemp+'>'))),255)else c:=command;
      cmprint(0,7,length(stemp+'>')+1,gmaxy-1,c);
      gotoxy(length(stemp+'>'+c)+1,gmaxy-1);
      if length(stemp+'>'+c)<80 then cmprint(0,7,1+length(stemp+'>'+c),gmaxy-1,space(80-length(stemp+'>'+c)));
      curon;
  end;
 right:
  begin
      if rp.treec=1 then stemp:=rp.pcnd else stemp:=copy(rp.pcnd,1,length(rp.pcnd)-1);
      cmprint(0,15,1,gmaxy-1,stemp+'>');
      if length(command)>78-length(stemp+'>')then c:=copy(command,(length(command)-(78-length(stemp+'>'))),255)else c:=command;
      cmprint(0,7,length(stemp+'>')+1,gmaxy-1,c);
      gotoxy(length(stemp+'>'+c)+1,gmaxy-1);
      if length(stemp+'>'+c)<80 then cmprint(0,7,1+length(stemp+'>'+c),gmaxy-1,space(80-length(stemp+'>'+c)));
      curon;
  end;
end;
if cmdlined then curon;
end;




procedure pcinfo;
var ink,paper,x,y:byte; stemp,nm:string; a,itemp:integer;
label cont1,cont2;
begin
    case lp.paneltype of
     pcpanel:
      begin
       a:=lp.pcfrom+lp.pcf-1;
       nm:=space(38);
       if (a>0)and(lp.pctdirs+lp.pctfiles>0) then
        Begin
         lp.pcnn:=lp.pcDir^[a].fname;
         if lp.pcnn[1]=' ' then delete(lp.pcnn,1,1);
         if nospace(lp.pcDir^[a].fext)<>'' then lp.pcnn:=lp.pcnn+'.'+lp.pcDir^[a].fext;
         lp.pcnn:=lp.pcnn+space(12-length(lp.pcnn));
         if a>lp.pctdirs then lp.pcnn:=strlo(lp.pcnn);

         stemp:=extnum(strr(lp.pcdir^[a].flength));
         if lp.pcdir^[a].flength>9999999 then stemp:=extnum(strr(lp.pcdir^[a].flength div 1000))+'K';
         if lp.pcdir^[a].flength>999999999 then stemp:=extnum(strr(lp.pcdir^[a].flength div 1000000))+'M';
         if (lp.pcdir^[a].flength<0) then if lang=rus then stemp:='⠫' else stemp:='SUB-DIR';
if (lp.pcdir^[a].flength<0)and(nospace(lp.pcnn)='..') then if lang=rus then stemp:='⠫' else stemp:='SUB-DIR';
         stemp:=changechar(stemp,' ',',');
         stemp:=space(10-length(stemp))+stemp;
         nm:=lp.pcnn+' '+stemp;

         stemp:=LZ(lp.pcdir^[a].fdt.day)+'-'+LZ(lp.pcdir^[a].fdt.month)+'-'+copy(LZ(lp.pcdir^[a].fdt.year),3,2);
         nm:=nm+' '+stemp;
         stemp:=LZ(lp.pcdir^[a].fdt.hour)+':'+LZ(lp.pcdir^[a].fdt.min);
         if stemp[1]='0' then stemp[1]:=' ';
         nm:=nm+' '+stemp;
        End;
       paper:=bkcurline; ink:=txtcurline; x:=2; y:=lp.putfrom+lp.panelhi+1;
       a:=0; for itemp:=1 to lp.pctdirs+lp.pctfiles do if lp.pcdir^[itemp].mark then inc(a);
       if (lp.infolines<=1)and(a<>0) then else
       cmprint(paper,ink,x,y,nm);{}
       lp.infoline:=nm;
       lp.bkinfoline:=paper;
       lp.txtinfoline:=ink;
       lp.xinfoline:=x;
       lp.yinfoline:=y;
      end;

     trdPanel:
      begin
       a:=0; for itemp:=2 to lp.trdtfiles do if lp.trddir^[itemp].mark then inc(a);
       if (lp.infolines<=1)and(a<>0) then goto cont1;
       nm:='<<'+space(36);
       a:=lp.trdfrom+lp.trdf-1;
       if a>1 then
        begin
         lp.trdnn:=lp.trddir^[a].name+'.'+lp.TRDOSe31(a);
         nm:=lp.trddir^[a].name+' '+lp.TRDOSe3(a);
         stemp:=extnum(strr(lp.trddir^[a].start)); stemp:=changechar(stemp,' ',',');
         nm:=nm+space(9-length(stemp))+stemp;

         stemp:=extnum(strr(lp.trddir^[a].length)); stemp:=changechar(stemp,' ',',');
         nm:=nm+space(9-length(stemp))+stemp;

         stemp:=strr(lp.trddir^[a].totalsec);
         stemp:='('+space(4-length(stemp))+stemp+')';

         nm:=nm+space(8-length(stemp))+stemp;
        end;
       paper:=bkcurline; ink:=txtcurline; x:=2; y:=lp.putfrom+lp.panelhi+1;
       cmprint(paper,ink,x,y,nm);{}
       lp.infoline:=nm;
       lp.bkinfoline:=paper;
       lp.txtinfoline:=ink;
       lp.xinfoline:=x;
       lp.yinfoline:=y;
cont1:
      end;

    end;

    case rp.paneltype of
     pcpanel:
      begin
       a:=0; for itemp:=1 to rp.pctdirs+rp.pctfiles do if rp.pcdir^[itemp].mark then inc(a);
       if (rp.infolines<=1)and(a<>0) then exit;{}
       a:=rp.pcfrom+rp.pcf-1;
       nm:=space(38);
       if (a>0)and(rp.pctdirs+rp.pctfiles>0) then
        Begin
         rp.pcnn:=rp.pcDir^[a].fname;
         if rp.pcnn[1]=' ' then delete(rp.pcnn,1,1);
         if nospace(rp.pcDir^[a].fext)<>'' then rp.pcnn:=rp.pcnn+'.'+rp.pcDir^[a].fext;
         rp.pcnn:=rp.pcnn+space(12-length(rp.pcnn));
         if a>rp.pctdirs then rp.pcnn:=strlo(rp.pcnn);

         stemp:=extnum(strr(rp.pcdir^[a].flength));
         if rp.pcdir^[a].flength>9999999 then stemp:=extnum(strr(rp.pcdir^[a].flength div 1000))+'K';
         if rp.pcdir^[a].flength>999999999 then stemp:=extnum(strr(rp.pcdir^[a].flength div 1000000))+'M';
         if (rp.pcdir^[a].flength<0) then if lang=rus then stemp:='⠫' else stemp:='SUB-DIR';
if (rp.pcdir^[a].flength<0)and(nospace(rp.pcnn)='..') then if lang=rus then stemp:='⠫' else stemp:='SUB-DIR';
         stemp:=changechar(stemp,' ',',');
         stemp:=space(10-length(stemp))+stemp;
         nm:=rp.pcnn+' '+stemp;

         stemp:=LZ(rp.pcdir^[a].fdt.day)+'-'+LZ(rp.pcdir^[a].fdt.month)+'-'+copy(LZ(rp.pcdir^[a].fdt.year),3,2);
         nm:=nm+' '+stemp;
         stemp:=LZ(rp.pcdir^[a].fdt.hour)+':'+LZ(rp.pcdir^[a].fdt.min);
         if stemp[1]='0' then stemp[1]:=' ';
         nm:=nm+' '+stemp;
        End;
       paper:=bkcurline; ink:=txtcurline; x:=42; y:=rp.putfrom+rp.panelhi+1;
       a:=0; for itemp:=1 to rp.pctdirs+rp.pctfiles do if rp.pcdir^[itemp].mark then inc(a);
       if (rp.infolines<=1)and(a<>0) then else
       cmprint(paper,ink,x,y,nm);{}
       rp.infoline:=nm;
       rp.bkinfoline:=paper;
       rp.txtinfoline:=ink;
       rp.xinfoline:=x;
       rp.yinfoline:=y;

      end;
     trdPanel:
      begin
       a:=0; for itemp:=2 to rp.trdtfiles do if rp.trddir^[itemp].mark then inc(a);
       if (rp.infolines<=1)and(a<>0) then goto cont2;
       nm:='<<'+space(36);
       a:=rp.trdfrom+rp.trdf-1;
       if a>1 then
        begin
         rp.trdnn:=rp.trddir^[a].name+'.'+rp.TRDOSe31(a);
         nm:=rp.trddir^[a].name+' '+rp.TRDOSe3(a);
         stemp:=extnum(strr(rp.trddir^[a].start)); stemp:=changechar(stemp,' ',',');
         nm:=nm+space(9-length(stemp))+stemp;

         stemp:=extnum(strr(rp.trddir^[a].length)); stemp:=changechar(stemp,' ',',');
         nm:=nm+space(9-length(stemp))+stemp;

         stemp:=strr(rp.trddir^[a].totalsec);
         stemp:='('+space(4-length(stemp))+stemp+')';

         nm:=nm+space(8-length(stemp))+stemp;
        end;
       paper:=bkcurline; ink:=txtcurline; x:=42; y:=rp.putfrom+rp.panelhi+1;
       cmprint(paper,ink,x,y,nm);{}
       rp.infoline:=nm;
       rp.bkinfoline:=paper;
       rp.txtinfoline:=ink;
       rp.xinfoline:=x;
       rp.yinfoline:=y;

cont2:
      end;
    end;
{if rMoused then MouseShow;{}
end;



procedure pcSelInfo;
var x,y,c,i:integer; byt:longint; sp,sline:string;
begin

c:=0; byt:=0;
case lp.paneltype of
 pcPanel:
         begin
          x:=2; y:=lp.putfrom+lp.panelhi+2;

        if mayputsiline then
         begin
          for i:=1 to lp.pctdirs do if lp.pcdir^[i].mark then
           begin inc(c); if lp.pcdir^[i].flength>=0 then inc(byt,lp.pcdir^[i].flength); end;
          for i:=lp.pctdirs+1 to lp.pctdirs+lp.pctfiles do
           if lp.pcdir^[i].mark then begin inc(c); inc(byt,lp.pcdir^[i].flength); end;
          if lp.infolines<=1 then dec(y);
          if lang=rus then sline:='  ⬥祭' else sline:='No files selected';
          if c>0 then if lang=rus
      then sline:='~`'+changechar(extnum(strr(byt)),' ',',')+'~`  ⬥祭  ~`'+strr(c)+'~` 䠩'+ewfiles(c,rus)
      else sline:='~`'+changechar(extnum(strr(byt)),' ',',')+'~` bytes selected in ~`'+strr(c)+'~` file'+ewfiles(c,lang);
          i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
          sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
          lp.mayselinfoline:=false;
          if (lp.infolines=1)and(c=0) then else lp.mayselinfoline:=true;
          StatusLineColor(bkSelectedNT,txtSelectedNT,bkSelectedST,txtSelectedST,x,y,sp);
          lp.selinfoline:=sp;
          lp.bknselinfoline:=bkSelectedNT; lp.txtnselinfoline:=txtSelectedNT;
          lp.bksselinfoline:=bkSelectedST; lp.txtsselinfoline:=txtSelectedST;
          lp.xselinfoline:=x;
          lp.yselinfoline:=y;
         end;


          lp.mayfreeline:=false;
          if lp.infolines>2 then
           begin
            byt:=diskfree(ord(lp.pcnd[1])-64); sp:=extnum(strr(byt));
            if byt>999999999 then sp:=extnum(strr(byt div 1000000))+'G';
            sline:=changechar(sp,' ',',');
            if lang=rus then sp:='~`'+sline+'~`  ᢮  ᪥ ~`'
                        else sp:='~`'+sline+'~` bytes free on drive ~`';
            sline:=sp+lp.pcnd[1]+':~`';
            i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
            sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);

            StatusLineColor(bkFreeLineNT,txtFreeLineNT,bkFreeLineST,txtFreeLineST,x,y+1,sp);{}
            lp.selinfoline:=sp;
            lp.bknfreeline:=bkFreeLineNT; lp.txtnfreeline:=txtFreeLineNT;
            lp.bksfreeline:=bkFreeLineST; lp.txtsfreeline:=txtFreeLineST;
            lp.xfreeline:=x;
            lp.yfreeline:=y;
            lp.mayfreeline:=true;
           end;


         end;
 trdPanel:
         begin
          for i:=2 to lp.trdtfiles do if lp.trddir^[i].mark then
           begin inc(c); inc(byt,lp.trddir^[i].totalsec); end;
          x:=2; y:=lp.putfrom+lp.panelhi+2;
          if lp.infolines<=1 then dec(y);
          if lang=rus then sline:='  ⬥祭' else sline:='No files selected';
          if c>0 then if lang=rus then sline:='~`'+changechar(extnum(strr(byt)),' ',',')+
                             '~` '+eb(byt,rus)+' ⬥祭  ~`'+strr(c)+'~` 䠩'+ewfiles(c,rus)
                             else sline:='~`'+changechar(extnum(strr(byt)),' ',',')+
                             '~` block'+eb(byt,lang)+' selected in ~`'+strr(c)+'~` file'+ewfiles(c,lang);
          i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
          sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
          lp.mayselinfoline:=false;
          if (lp.infolines=1)and(c=0) then else lp.mayselinfoline:=true;
          StatusLineColor(bkSelectedNT,txtSelectedNT,bkSelectedST,txtSelectedST,x,y,sp);{}
          lp.selinfoline:=sp;
          lp.bknselinfoline:=bkSelectedNT; lp.txtnselinfoline:=txtSelectedNT;
          lp.bksselinfoline:=bkSelectedST; lp.txtsselinfoline:=txtSelectedST;
          lp.xselinfoline:=x;
          lp.yselinfoline:=y;

          lp.mayfreeline:=false;
          if lp.infolines>2 then
           begin
            byt:=lp.trddisk.free;
            sline:=strr(byt);
            if lang=rus then sp:='~`'+sline+'~` '+eb(byt,rus)+' ᢮~`'
            else sp:='~`'+sline+'~` free blocks~`';
            sline:=sp+'~`';
            i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
            sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
            StatusLineColor(bkFreeLineNT,txtFreeLineNT,bkFreeLineST,txtFreeLineST,x,y+1,sp);{}
            lp.selinfoline:=sp;
            lp.bknfreeline:=bkFreeLineNT; lp.txtnfreeline:=txtFreeLineNT;
            lp.bksfreeline:=bkFreeLineST; lp.txtsfreeline:=txtFreeLineST;
            lp.xfreeline:=x;
            lp.yfreeline:=y;
            lp.mayfreeline:=true;
           end;

         end;
end;


c:=0; byt:=0;
case rp.paneltype of
 pcPanel:
         begin
          x:=42; y:=rp.putfrom+rp.panelhi+2;
        if mayputsiline then
         begin
          for i:=1 to rp.pctdirs do if rp.pcdir^[i].mark then
           begin inc(c); if rp.pcdir^[i].flength>=0 then inc(byt,rp.pcdir^[i].flength); end;
          for i:=rp.pctdirs+1 to rp.pctdirs+rp.pctfiles do
           if rp.pcdir^[i].mark then begin inc(c); inc(byt,rp.pcdir^[i].flength); end;
          if rp.infolines<=1 then dec(y);
          if lang=rus then sline:='  ⬥祭' else sline:='No files selected';
if c>0 then if lang=rus then
       sline:='~`'+changechar(extnum(strr(byt)),' ',',')+'~`  ⬥祭  ~`'+strr(c)+'~` 䠩'+ewfiles(c,rus)
  else sline:='~`'+changechar(extnum(strr(byt)),' ',',')+'~` bytes selected in ~`'+strr(c)+'~` file'+ewfiles(c,lang);
          i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
          sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
          rp.mayselinfoline:=false;
          if (rp.infolines=1)and(c=0) then else rp.mayselinfoline:=true;
          StatusLineColor(bkSelectedNT,txtSelectedNT,bkSelectedST,txtSelectedST,x,y,sp);{}
          rp.selinfoline:=sp;
          rp.bknselinfoline:=bkSelectedNT; rp.txtnselinfoline:=txtSelectedNT;
          rp.bksselinfoline:=bkSelectedST; rp.txtsselinfoline:=txtSelectedST;
          rp.xselinfoline:=x;
          rp.yselinfoline:=y;
         end;


          rp.mayfreeline:=false;
          if rp.infolines>2 then
           begin
            byt:=diskfree(ord(rp.pcnd[1])-64); sp:=extnum(strr(byt));
            if byt>999999999 then sp:=extnum(strr(byt div 1000000))+'G';
            sline:=changechar(sp,' ',',');
            if lang=rus then sp:='~`'+sline+'~`  ᢮  ᪥ ~`'
            else sp:='~`'+sline+'~` bytes free on drive ~`';
            sline:=sp+rp.pcnd[1]+':~`';
            i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
            sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
            StatusLineColor(bkFreeLineNT,txtFreeLineNT,bkFreeLineST,txtFreeLineST,x,y+1,sp);{}
            rp.selinfoline:=sp;
            rp.bknfreeline:=bkFreeLineNT; rp.txtnfreeline:=txtFreeLineNT;
            rp.bksfreeline:=bkFreeLineST; rp.txtsfreeline:=txtFreeLineST;
            rp.xfreeline:=x;
            rp.yfreeline:=y;
            rp.mayfreeline:=true;
           end;

         end;
 trdPanel:
         begin
          for i:=2 to rp.trdtfiles do if rp.trddir^[i].mark then
           begin inc(c); inc(byt,rp.trddir^[i].totalsec); end;
          x:=42; y:=rp.putfrom+rp.panelhi+2;
          if rp.infolines<=1 then dec(y);
          if lang=rus then sline:='  ⬥祭' else sline:='No files selected';
          if c>0 then if lang=rus then
             sline:='~`'+changechar((strr(byt)),' ',',')+
                             '~` '+eb(byt,rus)+' ⬥祭  ~`'+strr(c)+'~` 䠩'+ewfiles(c,rus)
             else sline:='~`'+changechar((strr(byt)),' ',',')+
                             '~` block'+eb(byt,lang)+' selected in ~`'+strr(c)+'~` file'+ewfiles(c,lang);
          i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
          sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
          rp.mayselinfoline:=false;
          if (rp.infolines=1)and(c=0) then else rp.mayselinfoline:=true;
          StatusLineColor(bkSelectedNT,txtSelectedNT,bkSelectedST,txtSelectedST,x,y,sp);{}
          rp.infoline:=sp;
          rp.bknselinfoline:=bkSelectedNT; rp.txtnselinfoline:=txtSelectedNT;
          rp.bksselinfoline:=bkSelectedST; rp.txtsselinfoline:=txtSelectedST;
          rp.xselinfoline:=x;
          rp.yselinfoline:=y;

          rp.mayfreeline:=false;
          if rp.infolines>2 then
           begin
            byt:=rp.trddisk.free;
            sline:=strr(byt);
            if lang=rus then sp:='~`'+sline+'~` '+eb(byt,rus)+' ᢮~`'
            else sp:='~`'+sline+'~` block'+eb(byt,lang)+' free~`';
            sline:=sp+'~`';
            i:=19-(length(without(sline,'~`'))div 2); if i<0 then i:=0;
            sp:=space(i)+sline; sp:=sp+space(abs(38-CClen(sp))); if CClen(sp)>38 then delete(sp,39+8,10);
            StatusLineColor(bkFreeLineNT,txtFreeLineNT,bkFreeLineST,txtFreeLineST,x,y+1,sp);{}
            rp.selinfoline:=sp;
            rp.bknfreeline:=bkFreeLineNT; rp.txtnfreeline:=txtFreeLineNT;
            rp.bksfreeline:=bkFreeLineST; rp.txtsfreeline:=txtFreeLineST;
            rp.xfreeline:=x;
            rp.yfreeline:=y;
            rp.mayfreeline:=true;
           end;

         end;
end;

{if rMoused then MouseShow;{}
end;






procedure pcdirinfo;
var s:string; i,p,x,d,a,b:byte;
begin

case lp.paneltype of
 pcPanel:
          begin
           if lp.treec=1 then s:=' '+lp.pcnd+' ' else s:=' '+copy(lp.pcnd,1,length(lp.pcnd)-1)+' ';
           if length(s)>29 then s:=copy(s,1,4)+'...'+copy(s,length(s)-22,30);
           if focus=left then begin p:=bkNDactive; i:=txtNDactive; end else begin p:=bkNDpassive; i:=txtNDpassive; end;
           cmprint(BkRama,TxtRama,lp.posx,lp.posy,'ͻ');
           if TRDOS3 then cmprint(BkRama,TxtRama,lp.posx+2,lp.posy,'T3');
           x:=21-length(s)div 2;
           cmprint(p,i,x,1,s);
           if Disklined then
            begin
            s:='';
            whatflopp(a,b);
            if a<>0 then s:=s+'A';
            if b<>0 then s:=s+'B';
             s:=s+getalldrivers;
             cmprint(bkDiskLineR,txtDiskLineR,lp.posx+1,lp.panellong+4,'[ ');
             d:=lp.posx+3;
             for x:=1 to length(s) do
              begin
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               if s[x]=lp.pcnd[1] then begin p:=bkDiskLineST; i:=txtDiskLineST; end;
               cmprint(p,i,d,lp.panellong+4,s[x]);
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               inc(d);
               if length(s)<17 then begin cmprint(p,i,d,lp.panellong+4,' '); inc(d); end;
              end;
             cmprint(bkDiskLineR,txtDiskLineR,d-1,lp.panellong+4,' ]'+fill(39-d,''));
            end;
          end;
 trdPanel:
          begin
           s:=' '+nospaceLR(lp.trddisk.disklabel)+' ';
           if focus=left then begin p:=bkNDactive; i:=txtNDactive; end else begin p:=bkNDpassive; i:=txtNDpassive; end;
           cmprint(BkRama,TxtRama,lp.posx,lp.posy,'ͻ');
           if TRDOS3 then cmprint(BkRama,TxtRama,lp.posx+2,lp.posy,'T3');
           x:=21-length(s)div 2;
           cmprint(p,i,x,1,s);
           if Disklined then
            begin
            s:='';
            whatflopp(a,b);
            if a<>0 then s:=s+'A';
            if b<>0 then s:=s+'B';
             s:=s+getalldrivers;
             cmprint(bkDiskLineR,txtDiskLineR,lp.posx+1,lp.panellong+4,'[ ');
             d:=lp.posx+3;
             for x:=1 to length(s) do
              begin
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               if s[x]=lp.pcnd[1] then begin p:=bkDiskLineST; i:=txtDiskLineST; end;
               cmprint(p,i,d,lp.panellong+4,s[x]);
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               inc(d);
               if length(s)<17 then begin cmprint(p,i,d,lp.panellong+4,' '); inc(d); end;
              end;
             cmprint(bkDiskLineR,txtDiskLineR,d-1,lp.panellong+4,' ]'+fill(39-d,''));
            end;
          end;
end;

case rp.paneltype of
 pcPanel:
          begin
           if rp.treec=1 then s:=' '+rp.pcnd+' ' else s:=' '+copy(rp.pcnd,1,length(rp.pcnd)-1)+' ';
           if length(s)>29 then s:=copy(s,1,4)+'...'+copy(s,length(s)-22,30);
           if focus=right then begin p:=bkNDactive; i:=txtNDactive; end else begin p:=bkNDpassive; i:=txtNDpassive; end;
           x:=61-length(s)div 2;
           if clocked then
            begin
             cmprint(BkRama,TxtRama,rp.posx,rp.posy,'');
             if x+length(s)>71 then begin d:=x+length(s)-71; s:=copy(s,1,4)+'...'+copy(s,8+d,30); end;
            end
           else cmprint(BkRama,TxtRama,rp.posx,rp.posy,'ͻ');
           cmprint(p,i,x,1,s);
           if TRDOS3 then cmprint(BkRama,TxtRama,rp.posx+2,rp.posy,'T3');
           if Disklined then
            begin
            s:='';
            whatflopp(a,b);
            if a<>0 then s:=s+'A';
            if b<>0 then s:=s+'B';
             s:=s+getalldrivers;
             cmprint(bkDiskLineR,txtDiskLineR,rp.posx+1,rp.panellong+4,'[ ');
             d:=rp.posx+3;
             for x:=1 to length(s) do
              begin
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               if s[x]=rp.pcnd[1] then begin p:=bkDiskLineST; i:=txtDiskLineST; end;
               cmprint(p,i,d,rp.panellong+4,s[x]);
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               inc(d);
               if length(s)<17 then begin cmprint(p,i,d,rp.panellong+4,' '); inc(d); end;
              end;
             cmprint(bkDiskLineR,txtDiskLineR,d-1,rp.panellong+4,' ]'+fill(79-d,''));
            end;
          end;
 trdPanel:
          begin
           s:=' '+nospaceLR(rp.trddisk.disklabel)+' ';
           if focus=right then begin p:=bkNDactive; i:=txtNDactive; end else begin p:=bkNDpassive; i:=txtNDpassive; end;
           x:=61-length(s)div 2;
           if clocked then
            begin
             cmprint(BkRama,TxtRama,rp.posx,rp.posy,'');
             if x+length(s)>71 then begin d:=x+length(s)-71; s:=copy(s,1,4)+'...'+copy(s,8+d,30); end;
            end
           else cmprint(BkRama,TxtRama,rp.posx,rp.posy,'ͻ');
           cmprint(p,i,x,1,s);
           if TRDOS3 then cmprint(BkRama,TxtRama,rp.posx+2,rp.posy,'T3');
           if Disklined then
            begin
            s:='';
            whatflopp(a,b);
            if a<>0 then s:=s+'A';
            if b<>0 then s:=s+'B';
             s:=s+getalldrivers;
             cmprint(bkDiskLineR,txtDiskLineR,rp.posx+1,rp.panellong+4,'[ ');
             d:=rp.posx+3;
             for x:=1 to length(s) do
              begin
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               if s[x]=rp.pcnd[1] then begin p:=bkDiskLineST; i:=txtDiskLineST; end;
               cmprint(p,i,d,rp.panellong+4,s[x]);
               p:=bkDiskLineNT; i:=txtDiskLineNT;
               inc(d);
               if length(s)<17 then begin cmprint(p,i,d,rp.panellong+4,' '); inc(d); end;
              end;
             cmprint(bkDiskLineR,txtDiskLineR,d-1,rp.panellong+4,' ]'+fill(79-d,''));
            end;
          end;
end;
{if rMoused then MouseShow;{}
end;



procedure infopanel;
begin
if lp.paneltype=infPanel then
 begin
  case rp.paneltype of
   pcPanel:  pcPutInfoRight(true);
   trdPanel: trdPutInfoRight(true);
  end;
 end;
if rp.paneltype=infPanel then
 begin
  case lp.paneltype of
   pcPanel:  pcPutInfoLeft(true);
   trdPanel: trdPutInfoLeft(true);
  end;
 end;


end;










function checkpath(p:pathstr):pathstr;
var ie,er:integer; prev:pathstr;
begin
getdir(0,prev);{}
if (p[length(p)]='\')and(length(p)>3){} then delete(p,length(p),1);
{$I-}
chdir(p);
{$I+}
er:=ioresult;
if (er=15)or(er=152) then
 begin
  checkpath:='C:\';
  from:=1; f:=1;
  exit;
 end;
if er<>0 then
 begin
  for ie:=1 to length(p)-length(without(p,'\')) do
   begin
    delete(p,length(p)-pos('\',reversestr(copy(p,1,length(p)-1))),255);
    {$I-}
    chdir(p);
    {$I+}
    if ioresult=0 then
     begin
      break;
     end;
    if length(p)<3 then
     begin
      p:=p[1]+':\';
      break;
     end;
   end;
 end;

if p[length(p)]<>'\' then p:=p+'\';{}
checkpath:=p;

if checkdir(prev)<>0 then prev:=checkpath(prev);
chdir(prev);{}
end;




procedure pcInverseLeft;
var i:integer;
                      begin
                       for i:=lp.pctdirs+1 to lp.pctdirs+lp.pctfiles do
                        lp.pcdir^[i].mark:=not lp.pcdir^[i].mark;
                       lp.pcPDF(lp.pcfrom);
                       pcselinfo;
                      end;



procedure pcInverseRight;
var i:integer;
                      begin
                       for i:=rp.pctdirs+1 to rp.pctdirs+rp.pctfiles do
                        rp.pcdir^[i].mark:=not rp.pcdir^[i].mark;
                       rp.pcPDF(rp.pcfrom);
                       pcselinfo;
                      end;


function GetWildMask(tit,curentmask:string):string;
var newmask:string;
begin
 colour(bkdRama,txtdRama);
 scputwin(bkdRama,txtdRama,29,halfmaxy-4,52,halfmaxy+3);
 cmcentre(bkdRama,txtdRama,halfmaxy-4,tit);
 colour(bkdLabelNT,txtdLabelNT);

 if lang=rus then cmprint(bkdLabelST,txtdLabelST,33,halfmaxy-2,'c')
             else cmprint(bkdLabelST,txtdLabelST,33,halfmaxy-2,'Mask');
 cbutton(bkdButtonA,txtdButtonA,36,halfmaxy+1,'    OK    ',true);

 colour(bkdInputNT,txtdInputNT);
 curon;
 newmask:=scanf(32,halfmaxy-1,curentmask,18,18,1);
 curoff;
 restscr;
 if scanf_esc then GetWildMask:=curentmask else GetWildMask:=newmask;

end;




procedure pcMinusLeft;
var i:integer;
                      begin
                       if lang=rus then stemp:=' ⬥ ' else stemp:=' Cancel ';
                       minusmask:=nospace(GetWildMask(stemp,minusmask));
                       if scanf_esc then exit;
                       for i:=lp.pctdirs+1 to lp.pctdirs+lp.pctfiles do
                        begin
                         stemp:=nospace(lp.pcdir^[i].fname+'.'+lp.pcdir^[i].fext);
                         if wild(stemp,minusmask,true) then lp.pcdir^[i].mark:=false;
                        end;
                       lp.pcPDF(lp.pcfrom);
                       pcselinfo; putcmdline;
                      end;




procedure pcMinusRight;
var i:integer;
                      begin
                       if lang=rus then stemp:=' ⬥ ' else stemp:=' Cancel ';
                       minusmask:=nospace(GetWildMask(stemp,minusmask));
                       if scanf_esc then exit;
                       for i:=rp.pctdirs+1 to rp.pctdirs+rp.pctfiles do
                        begin
                         stemp:=nospace(rp.pcdir^[i].fname+'.'+rp.pcdir^[i].fext);
                         if wild(stemp,minusmask,true) then rp.pcdir^[i].mark:=false;
                        end;
                       rp.pcPDF(rp.pcfrom);
                       pcselinfo; putcmdline;
                      end;




procedure pcPlusLeft;
var i:integer;
                      begin
                       if lang=rus then stemp:=' 롮p ' else stemp:=' Select ';
                       plusmask:=nospace(GetWildMask(stemp,plusmask));
                       if scanf_esc then exit;
                       for i:=lp.pctdirs+1 to lp.pctdirs+lp.pctfiles do
                        begin
                         stemp:=nospace(lp.pcdir^[i].fname+'.'+lp.pcdir^[i].fext);
                         if wild(stemp,plusmask,true) then lp.pcdir^[i].mark:=true;
                        end;
                       lp.pcPDF(lp.pcfrom);
                       pcselinfo; putcmdline;
                      end;



procedure pcPlusRight;
var i:integer;
                      begin
                       if lang=rus then stemp:=' 롮p ' else stemp:=' Select ';
                       plusmask:=nospace(GetWildMask(stemp,plusmask));
                       if scanf_esc then exit;
                       for i:=rp.pctdirs+1 to rp.pctdirs+rp.pctfiles do
                        begin
                         stemp:=nospace(rp.pcdir^[i].fname+'.'+rp.pcdir^[i].fext);
                         if wild(stemp,plusmask,true) then rp.pcdir^[i].mark:=true;
                        end;
                       rp.pcPDF(rp.pcfrom);
                       pcselinfo; putcmdline;
                      end;



procedure pcCtrlPlusLeft;
var i:integer;
                      begin
                       for i:=1 to lp.pctdirs do
                       if (i=1)and(lp.treec>1) then else
                        lp.pcdir^[i].mark:=true;
                       lp.pcPDF(lp.pcfrom);
                       pcselinfo;
                      end;



procedure pcCtrlPlusRight;
var i:integer;
                      begin
                       for i:=1 to rp.pctdirs do
                       if (i=1)and(rp.treec>1) then else
                        rp.pcdir^[i].mark:=true;
                       rp.pcPDF(rp.pcfrom);
                       pcselinfo;
                      end;



procedure pcInsLeft;
var i,c:word;
                      begin
                       if (lp.treec=1)or((lp.treec>1)and(from+f-1>1)) then
                       lp.pcdir^[from+f-1].mark:=not lp.pcdir^[from+f-1].mark;
                       inc(f);
                       if f>lp.pctdirs+lp.pctfiles then f:=lp.pctdirs+lp.pctfiles;
                       {
                       c:=0;
                       for i:=1 to lp.pctdirs+lp.pctfiles do if lp.pcdir^[i].mark then
                        begin
                         inc(c);
                         lp.pcins^[c].crc16:=crc16(lp.pcdir^[i].fname+'.'+lp.pcdir^[i].fext);
                        end;
                       lp.pcinsed:=c;
                       {}
                       lp.pcPDF(lp.pcfrom);
                       pcselinfo;
                      end;
procedure pcInsRight;
var i,c:word;
                      begin
                       if (rp.treec=1)or((rp.treec>1)and(from+f-1>1)) then
                       rp.pcdir^[from+f-1].mark:=not rp.pcdir^[from+f-1].mark;
                       inc(f);
                       if f>rp.pctdirs+rp.pctfiles then f:=rp.pctdirs+rp.pctfiles;
                       {
                       c:=0;
                       for i:=1 to rp.pctdirs+rp.pctfiles do if rp.pcdir^[i].mark then
                        begin
                         inc(c);
                         rp.pcins^[c].crc16:=crc16(rp.pcdir^[i].fname+'.'+rp.pcdir^[i].fext);
                        end;
                       rp.pcinsed:=c;
                       {}
                       rp.pcPDF(rp.pcfrom);
                       pcselinfo;
                      end;


{=========Block For ZX============}
procedure trdInsLeft;
begin
if from+f-1>1 then
 if (ord(lp.trddir^[from+f-1].name[1])<>1)and(ord(lp.trddir^[from+f-1].name[1])<>0) then
  lp.trddir^[from+f-1].mark:=not lp.trddir^[from+f-1].mark;
 inc(f);
 if f>lp.trdtfiles then f:=lp.trdtfiles;
 lp.trdPDF(lp.trdfrom);
 pcselinfo;
end;


procedure trdInsRight;
begin
if from+f-1>1 then
 if (ord(rp.trddir^[from+f-1].name[1])<>1)and(ord(rp.trddir^[from+f-1].name[1])<>0) then
  rp.trddir^[from+f-1].mark:=not rp.trddir^[from+f-1].mark;
 inc(f);
 if f>rp.trdtfiles then f:=rp.trdtfiles;
 rp.trdPDF(rp.trdfrom);
 pcselinfo;
end;


procedure trdPlusLeft;
var i:integer;
begin
 if lang=rus then stemp:=' 롮p ' else stemp:=' Select ';
 trdplusmask:=nospaceLR(GetWildMask(stemp,trdplusmask));
 if scanf_esc then exit;
 for i:=2 to lp.trdtfiles do if (ord(lp.trddir^[i].name[1])<>1)and(ord(lp.trddir^[i].name[1])<>0) then
  begin
   stemp:=nospaceLR(lp.trddir^[i].name)+'.'+lp.trddir^[i].typ;
   if TRDOS3 then stemp:=stemp+chr(lo(rp.trddir^[i].start))+chr(hi(rp.trddir^[i].start));
   if wild(stemp,trdplusmask,false) then lp.trddir^[i].mark:=true;
  end;
 lp.trdPDF(lp.trdfrom);
 pcselinfo;
end;


procedure trdPlusRight;
var i:integer;
begin
 if lang=rus then stemp:=' 롮p ' else stemp:=' Select ';
 trdplusmask:=nospaceLR(GetWildMask(stemp,trdplusmask));
 if scanf_esc then exit;
 for i:=2 to rp.trdtfiles do if (ord(rp.trddir^[i].name[1])<>1)and(ord(rp.trddir^[i].name[1])<>0) then
  begin
   stemp:=nospaceLR(rp.trddir^[i].name)+'.'+rp.trddir^[i].typ;
   if TRDOS3 then stemp:=stemp+chr(lo(rp.trddir^[i].start))+chr(hi(rp.trddir^[i].start));
   if wild(stemp,trdplusmask,false) then rp.trddir^[i].mark:=true;
  end;
 rp.trdPDF(rp.trdfrom);
 pcselinfo;
end;


procedure trdMinusLeft;
var i:integer;
begin
 if lang=rus then stemp:=' ⬥ ' else stemp:=' Cancel ';
 trdminusmask:=nospaceLR(GetWildMask(stemp,trdminusmask));
 if scanf_esc then exit;
 for i:=2 to lp.trdtfiles do
  begin
   stemp:=nospaceLR(lp.trddir^[i].name)+'.'+lp.trddir^[i].typ;
   if TRDOS3 then stemp:=stemp+chr(lo(rp.trddir^[i].start))+chr(hi(rp.trddir^[i].start));
   if wild(stemp,trdminusmask,false) then lp.trddir^[i].mark:=false;
  end;
 lp.trdPDF(lp.trdfrom);
 pcselinfo;
end;


procedure trdMinusRight;
var i:integer;
begin
 if lang=rus then stemp:=' ⬥ ' else stemp:=' Cancel ';
 trdminusmask:=nospaceLR(GetWildMask(stemp,trdminusmask));
 if scanf_esc then exit;
 for i:=2 to rp.trdtfiles do
  begin
   stemp:=nospaceLR(rp.trddir^[i].name)+'.'+rp.trddir^[i].typ;
   if TRDOS3 then stemp:=stemp+chr(lo(rp.trddir^[i].start))+chr(hi(rp.trddir^[i].start));
   if wild(stemp,trdminusmask,false) then rp.trddir^[i].mark:=false;
  end;
 rp.trdPDF(rp.trdfrom);
 pcselinfo;
end;


procedure trdInverseLeft;
var i:integer;
begin
 for i:=2 to lp.trdtfiles do if (ord(lp.trddir^[i].name[1])<>1)and(ord(lp.trddir^[i].name[1])<>0) then
  lp.trddir^[i].mark:=not lp.trddir^[i].mark;
 lp.trdPDF(lp.trdfrom);
 pcselinfo;
end;


procedure trdInverseRight;
var i:integer;
begin
 for i:=2 to rp.trdtfiles do if (ord(rp.trddir^[i].name[1])<>1)and(ord(rp.trddir^[i].name[1])<>0) then
  rp.trddir^[i].mark:=not rp.trddir^[i].mark;
 rp.trdPDF(rp.trdfrom);
 pcselinfo;
end;

function bpos(tr,sc:byte):longint;
var a,b,c,d,s:longint;
begin
s:=0;
a:=4096;
b:=tr*a;
s:=s+b;
c:=256;
d:=sc*c;
s:=s+d;
bpos:=s;
end;






begin
{=========Block For PC============}
makeboot:=false;

{=========Block For ZX============}
end.